require 'thor'

module Coredb
  module Application
    module Devopstools
      class Helper
        #for testing purpose
        def self.setup_query(endpoint, environment)
          sparql = SPARQL::Client.new(endpoint)
          query = sparql.query("select ?var ?value where {?s <http://geophy.io/ontologies/devops#environment_name> '#{environment}' . ?s <http://geophy.io/ontologies/devops#variable_detail> ?allvars . ?allvars  <http://geophy.io/ontologies/devops#variable_name> ?var ; <http://geophy.io/ontologies/devops#value> ?value }")

          puts "#!/bin/bash --login"
          query.each_solution do |solution|
            puts "export #{solution[:var]}=#{solution[:value]}"
          end
          return query
        end
        #for testing purpose
        def self.list_query(endpoint)
          sparql = SPARQL::Client.new(endpoint)
          query = sparql.query("select ?envs where {?s <http://geophy.io/ontologies/devops#environment_name> ?envs .}")

          query.each_solution do |solution|
            puts "#{solution[:envse]}"
          end
          return query
        end
      end
      class Commands < Thor

        desc "setup ENVIRONMENT", "set environemnt variable for configuration. E.g.: setup production"
        long_desc <<-TEXT_HELP

    `setup ENVIRONMENT` will print out a shell script with all environment variables that needs to be set for the environment.

    This will read the devops ontology from DEVOPS_REGISTER and get all variables that needs to be set.
    As we cannot set variables via programming language, it will print them in the devopstools.
    So this can be pipe into a tmp file and execute by an external rotine.

        TEXT_HELP

        def setup(environment)
          if ENV["DEVOPS_REGISTER"] == nil
            puts "Please set the endpoint (DEVOPS_REGISTER) where the variables are configured"
            return false
          end
          Helper.setup_query(ENV["DEVOPS_REGISTER"], environment)
          return true
        end

        desc "list ", "list all available ENVIRONMENT"
        long_desc <<-TEXT_HELP

    `list` will print out all available environments.

    This will read the devops ontology from DEVOPS_REGISTER and print the environment names that are configured.

        TEXT_HELP

        def list()
          if ENV["DEVOPS_REGISTER"] == nil
            puts "Please set the endpoint (DEVOPS_REGISTER) where the variables are configured"
            return false
          end
          Helper.list_query(ENV["DEVOPS_REGISTER"])
          return true
        end


      end
    end
  end
end